package org.dromara.web.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;

import org.dromara.common.redis.utils.RedisUtils;
import org.dromara.system.config.RedisUtil;
import org.dromara.system.domain.SysDept;
import org.dromara.system.domain.vo.SysDeptVo;
import org.dromara.system.mapper.SysDeptMapper;
import org.dromara.system.service.ISysDeptService;
import org.dromara.web.domain.TreatmentUser;
import org.dromara.web.domain.bo.TreatmentUserBo;
import org.dromara.web.domain.vo.TreatmentUserVo;
import org.dromara.web.mapper.TreatmentUserMapper;
import org.dromara.web.service.ITreatmentUserService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 待诊患者 Service业务层处理
 *
 * @author Lion Li
 * @date 2025-06-24
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class TreatmentUserServiceImpl implements ITreatmentUserService {

    private final TreatmentUserMapper baseMapper;

    private final ISysDeptService deptService;

    private final SysDeptMapper deptMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 主键
     * @return 【请填写功能名称】
     */
    @Override
    public TreatmentUserVo queryById(Long id) {
        TreatmentUserVo treatmentUserVo = baseMapper.selectVoById(id);
        SysDeptVo deptVo = null;
        if (null != treatmentUserVo) {
            deptVo = deptService.selectDeptById(treatmentUserVo.getDoorId());
            if (null != deptVo) {
                treatmentUserVo.setDeptName(deptVo.getDeptName());
            }
        }
        return treatmentUserVo;
    }

    /**
     * 分页查询【请填写功能名称】列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 【请填写功能名称】分页列表
     */
    @Override
    public TableDataInfo<TreatmentUserVo> queryPageList(TreatmentUserBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TreatmentUser> lqw = buildQueryWrapper(bo);
        List<SysDept> deptlList = deptMapper.selectList(Wrappers.lambdaQuery(SysDept.class).select(SysDept::getDeptId, SysDept::getDeptName));
        Map<Long, String> deptMap = deptlList.stream().collect(Collectors.toMap(k1 -> k1.getDeptId(), k2 -> String.valueOf(k2.getDeptName()), (k1, k2) -> k1));
        List<TreatmentUserVo> result = baseMapper.selectVoList(lqw);
        if (null != result) {
            for (TreatmentUserVo vo : result) {
                vo.setDeptName(deptMap.get(vo.getDoorId()));
            }
        }
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的【请填写功能名称】列表
     *
     * @param bo 查询条件
     * @return 【请填写功能名称】列表
     */
    @Override
    public List<TreatmentUserVo> queryList(TreatmentUserBo bo) {
        LambdaQueryWrapper<TreatmentUser> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TreatmentUser> buildQueryWrapper(TreatmentUserBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TreatmentUser> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TreatmentUser::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getType()), TreatmentUser::getType, bo.getType());
        lqw.eq(bo.getDoorId() != null, TreatmentUser::getDoorId, bo.getDoorId());
        lqw.eq(bo.getEvaluationStatus() != null, TreatmentUser::getEvaluationStatus, bo.getEvaluationStatus());
        lqw.eq(bo.getTreatmentUserStatus() != null, TreatmentUser::getTreatmentUserStatus, bo.getTreatmentUserStatus());
        lqw.eq(StringUtils.isNotBlank(bo.getTreatNum()), TreatmentUser::getTreatNum, bo.getTreatNum());
        lqw.eq(StringUtils.isNotBlank(bo.getOutpatientNo()), TreatmentUser::getOutpatientNo, bo.getOutpatientNo());
        // 添加searchFlag的多字段模糊查询
        if (StringUtils.isNotBlank(bo.getSearchFlag())) {
            lqw.and(wrapper ->
                wrapper.like(TreatmentUser::getTreatName, bo.getSearchFlag())
                    .or()
                    .like(TreatmentUser::getOutpatientNo, bo.getSearchFlag())
                    .or()
                    .like(TreatmentUser::getIdCard, bo.getSearchFlag())
                    .or()
                    .like(TreatmentUser::getOutpatientNo, bo.getSearchFlag()));
        }
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TreatmentUserBo bo) {
        TreatmentUser add = MapstructUtils.convert(bo, TreatmentUser.class);
        add.setTreatNum(RedisUtil.generatePatientNumber("M"));
        if (null != add && StringUtils.isNotBlank(add.getType())) {
            if ("0".equals(add.getType())) {
                add.setOutpatientNo(RedisUtil.generatePatientNumber("2"));
            } else if ("1".equals(add.getType())) {
                add.setOutpatientNo(RedisUtil.generatePatientNumber("1"));
            }
        }
        add.setBirthday(bo.getBirthday());
        add.setPhoneNum(bo.getPhoneNum());
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TreatmentUserBo bo) {
        TreatmentUser update = MapstructUtils.convert(bo, TreatmentUser.class);
        update.setBirthday(bo.getBirthday());
        update.setPhoneNum(bo.getPhoneNum());
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TreatmentUser entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除【请填写功能名称】信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
